<ng-container *ngIf="vm$ | async as vm">
  <ng-container *subscribe="vm.pushDataMutation.result$ as pushData">
    <ngx-loading [show]="pushData.isLoading" />
  </ng-container>

  <app-header-catalog
    [catalog]="'mapset'"
    [label]="label"
    [description]="description"
    [breadcrumb]="breadcrumb"
  />

  <div [ngClass]="['e-walidata-page', jds.mt(30), jds.mb(70), jds.mx(0)]">
    <div [ngClass]="jds.container">
      <ng-container *ngIf="isOPD">
        <div [ngClass]="[jds.row, jds.mb(16)]">
          <div [ngClass]="[jds.col(12)]">
            <div [ngClass]="[jds.fw('bold'), jds.fs(21)]">Ringkasan Urusan</div>
          </div>
        </div>
        <ng-container *ngIf="vm.listUrusanOPD as listUrusanOPD">
          <ng-container *ngIf="listUrusanOPD.isSuccess">
            <ng-container
              *ngIf="(listUrusanOPD?.data?.list ?? []).length === 0"
            >
              <div [ngClass]="jds.row">
                <div [ngClass]="jds.col(12)">
                  <div [ngClass]="[jds.alert, jds.alertPrimary, jds.mb(12)]">
                    <div [ngClass]="[jds.d('flex')]">
                      <div [ngClass]="jds.alertIcon">
                        <jds-bi-icon
                          [ngClass]="jds.me(8)"
                          name="circle-info"
                        />
                      </div>
                      <div>Ringkasan Urusan saat ini belum tersedia.</div>
                    </div>
                  </div>
                </div>
              </div>
            </ng-container>
            <ng-container *ngIf="(listUrusanOPD?.data?.list ?? []).length > 0">
              <div [ngClass]="[jds.row, jds.mb(24)]">
                <div [ngClass]="[jds.col(12)]">
                  <div
                    [ngClass]="[
                      'tahun-filter',
                      jds.d('flex'),
                      jds.alignItems('center')
                    ]"
                  >
                    <span
                      [ngClass]="[
                        jds.me(8),
                        jds.fs(14),
                        jds.text(jdsBiColor.gray['700'])
                      ]"
                      >Tahun
                    </span>
                    <div [ngClass]="jds.w(86)">
                      <ng-select
                        [(ngModel)]="vm.filterTahunOPD"
                        [searchable]="false"
                        [clearable]="false"
                        [items]="vm.listTahun"
                        (change)="filterTahun($event)"
                        bindValue="value"
                        bindLabel="label"
                        placeholder="Tahun"
                      />
                    </div>
                  </div>
                </div>
              </div>
            </ng-container>
          </ng-container>

          <ng-container
            *ngIf="
              listUrusanOPD.isSuccess
                ? listUrusanOPD.isFetching
                : listUrusanOPD.isLoading
            "
          >
            <div [ngClass]="jds.row">
              <div
                *ngFor="let item of [1, 2, 3]"
                [ngClass]="[jds.col(12), jds.colMd(4)]"
              >
                <app-skeleton-catalog />
              </div>
            </div>
          </ng-container>

          <ng-container
            *ngIf="listUrusanOPD.isSuccess && !listUrusanOPD.isFetching"
          >
            <ng-container *ngIf="(listUrusanOPD?.data?.list ?? []).length > 0">
              <div [ngClass]="jds.row">
                <div
                  *ngFor="
                    let urusan of listUrusanOPD?.data?.list ?? [];
                    let i = index
                  "
                  [ngClass]="[
                    jds.col(12),
                    jds.colMd(4),
                    jds.mb(40),
                    jds.mbMd(0)
                  ]"
                >
                  <div
                    [ngClass]="jds.card"
                    [id]="'urusan-' + i"
                  >
                    <div [ngClass]="[jds.cardBody, jds.p(24)]">
                      <div
                        [ngClass]="[
                          jds.d('flex'),
                          jds.mb(14),
                          jds.alignItems('center')
                        ]"
                        [style.gap.px]="24"
                      >
                        <div [ngClass]="[jds.fw('bold'), jds.fs(37)]">
                          {{
                            urusan.progress?.toString()?.replace('.', ',') ?? 0
                          }}<span [ngClass]="jds.fs(28)">%</span>
                        </div>
                        <div
                          [style.width.px]="48"
                          [style.height.px]="48"
                          [ngClass]="
                            jds.circularProgress(
                              urusan.progress ?? 0,
                              48,
                              '#1FB767'
                            )
                          "
                        >
                          <div class="pie-wrapper">
                            <div class="pie">
                              <div class="left-side half-circle"></div>
                              <div class="right-side half-circle"></div>
                            </div>
                            <div class="shadow"></div>
                            <progress
                              [value]="urusan.progress ?? 0"
                              [style.visibility]="'hidden'"
                              [style.width]="0"
                              [style.height]="0"
                              min="0"
                              max="100"
                            ></progress>
                          </div>
                        </div>
                      </div>
                      <div [ngClass]="[jds.fw('bold'), jds.mb(4)]">
                        {{ urusan.nama_bidang_urusan ?? '-' }}
                      </div>
                      <div
                        [ngClass]="[
                          jds.text(jdsBiColor.gray['700']),
                          jds.mb(16),
                          jds.fs(14)
                        ]"
                      >
                        {{ urusan.kode_bidang_urusan ?? '-' }}
                      </div>

                      <div [ngClass]="[jds.me(16)]">
                        <div
                          [ngClass]="[jds.d('flex')]"
                          [style.verticalAlign]="'middle'"
                        >
                          <jds-bi-icon
                            [ngClass]="[
                              jds.me(6),
                              jds.text(jdsBiColor.gray['600'])
                            ]"
                            name="clock-three"
                          />
                          <span
                            [ngClass]="[jds.fs(14), jds.text('#757575')]"
                            [style.position]="'relative'"
                            [style.top.px]="0.5"
                            [style.lineHeight.px]="23"
                          >
                            Update terakhir:
                            {{
                              urusan.last_update
                                ? moment(urusan.last_update).format(
                                    'DD MMMM YYYY'
                                  )
                                : '-'
                            }}
                          </span>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </ng-container>
          </ng-container>
        </ng-container>
      </ng-container>
      <div
        *ngIf="isWalidata"
        [ngClass]="[jds.row, jds.mt(32)]"
      >
        <div>
          <ul
            #nav="jdsBiNav"
            [(activeId)]="tabActiveId"
            [ngClass]="['desk-tab-type', jds.alignItems('center')]"
            [colorScheme]="colorScheme"
            jdsBiNav
            variant="ghost"
          >
            <li [jdsBiNavItem]="'ringkasan-urusan'">
              <a
                (click)="onTabChanged('ringkasan-urusan')"
                jdsBiNavLink
              >
                Ringkasan Urusan
              </a>
            </li>
            <li [jdsBiNavItem]="'rincian-uraian'">
              <a
                (click)="onTabChanged('rincian-uraian')"
                jdsBiNavLink
              >
                Rincian Uraian
              </a>
            </li>
          </ul>
        </div>
      </div>
      <ng-container *ngIf="tabActiveId === 'ringkasan-urusan'">
        <div [ngClass]="[jds.row, jds.mb(16), jds.mt(16)]">
          <div [ngClass]="[jds.col(12)]">
            <div
              [ngClass]="[
                'tahun-filter',
                jds.d('flex'),
                jds.alignItems('center')
              ]"
            >
              <span
                [ngClass]="[
                  jds.me(8),
                  jds.fs(14),
                  jds.text(jdsBiColor.gray['700'])
                ]"
                >Tahun
              </span>
              <div [ngClass]="jds.w(86)">
                <ng-select
                  [(ngModel)]="vm.filterTahunWalidata"
                  [searchable]="false"
                  [clearable]="false"
                  [items]="vm.listTahun"
                  (change)="filterTahun($event)"
                  bindValue="value"
                  bindLabel="label"
                  placeholder="Tahun"
                />
              </div>
            </div>
          </div>
        </div>
        <div [ngClass]="[jds.row]">
          <app-e-walidata-list-ringkasan-urusan />
        </div>
      </ng-container>
      <ng-container *ngIf="tabActiveId === 'rincian-uraian'">
        <div
          *ngIf="isOPD && vm.listUrusanOPD?.data?.list?.length > 0"
          [ngClass]="[jds.row, jds.mb(16), jds.mt(16)]"
        >
          <div [ngClass]="[jds.col(12)]">
            <div [ngClass]="[jds.fw('bold'), jds.fs(21)]">Rincian Uraian</div>
          </div>
        </div>
        <ng-container
          *ngIf="vm.listUrusanOPD?.data?.list?.length > 0 || isWalidata"
        >
          <div [ngClass]="[jds.row, jds.mb(16), jds.mt(16)]">
            <div [ngClass]="[jds.col(12)]">
              <div [ngClass]="[jds.row, jds.justifyContent('between')]">
                <div
                  [ngClass]="[
                    jds.col(12),
                    jds.colMd(5),
                    jds.colLg(4),
                    jds.mb(8),
                    jds.mbMd(0)
                  ]"
                >
                  <ng-container
                    *ngIf="vm.bidangUrusanMasterData as bidangUrusanMasterData"
                  >
                    <ng-select
                      [(ngModel)]="vm.filterBidangUrusan"
                      [searchable]="true"
                      [clearable]="false"
                      [closeOnSelect]="true"
                      [items]="bidangUrusanMasterData?.data?.list ?? []"
                      [loading]="
                        bidangUrusanMasterData.isSuccess
                          ? bidangUrusanMasterData.isFetching
                          : bidangUrusanMasterData.isLoading
                      "
                      [typeahead]="
                        vm.paginationParamsMasterDataBidangUrusan.searchInput$
                      "
                      [searchFn]="disableLocalSearch()"
                      (change)="filterBidangUrusan($event)"
                      bindValue="kode_bidang_urusan"
                      bindLabel="label"
                      placeholder="Filter"
                    />
                  </ng-container>
                </div>
                <div [ngClass]="[jds.col(12), jds.colMd(5), jds.colLg(4)]">
                  <div>
                    <div
                      jdsBiInputGroup
                      variant="element"
                    >
                      <input
                        [(ngModel)]="vm.paginationParamsIndikatorUrusan.search"
                        [colorScheme]="colorScheme"
                        (keyup.enter)="
                          filterSearchIndikatorBidangUraian(
                            vm.paginationParamsIndikatorUrusan.search
                          )
                        "
                        placeholder="Cari Uraian atau Kode SSD"
                        name="search"
                        type="text"
                        jdsBiInput
                      />
                      <jds-bi-input-right-element>
                        <div
                          [ngClass]="[jds.d('flex'), jds.alignItems('center')]"
                        >
                          <jds-bi-icon
                            *ngIf="vm.paginationParamsIndikatorUrusan.search"
                            [ngClass]="[jds.me(8)]"
                            [color]="jdsBiColor.gray['500']"
                            [style.cursor]="'pointer'"
                            (click)="filterSearchIndikatorBidangUraian(null)"
                            name="circle-xmark"
                          />
                          <button
                            [colorScheme]="colorScheme"
                            [isIconOnly]="true"
                            (click)="
                              filterSearchIndikatorBidangUraian(
                                vm.paginationParamsIndikatorUrusan.search
                              )
                            "
                            jdsBiButton
                            variant="solid"
                          >
                            <jds-bi-icon
                              [size]="14"
                              name="magnifying-glass"
                            />
                          </button>
                        </div>
                      </jds-bi-input-right-element>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div [ngClass]="[jds.row]">
            <app-e-walidata-list-rincian-uraian />
          </div>
        </ng-container>
      </ng-container>
    </div>
  </div>
</ng-container>
